Index: win32ss/user/ntuser/menu.c
===================================================================
--- win32ss/user/ntuser/menu.c	(revision 68654)
+++ win32ss/user/ntuser/menu.c	(working copy)
@@ -1116,7 +1236,1957 @@
    return ( fByPos ) ? i : MenuItem->wID;
 }
 
+PMENU
+FASTCALL
+co_IntGetSubMenu(
+  PMENU pMenu,
+  int nPos)
+{
+  PITEM pItem;
+  if (!(pItem = MENU_FindItem( &pMenu, (UINT*)&nPos, MF_BYPOSITION ))) return NULL;
+
+  if (pItem->spSubMenu)
+  {
+     return pItem->spSubMenu;
+  }
+  return NULL;
+}
+
+/***********************************************************************
+ *           MenuInitSysMenuPopup
+ *
+ * Grey the appropriate items in System menu.
+ */
+void FASTCALL MENU_InitSysMenuPopup(PMENU menu, DWORD style, DWORD clsStyle, LONG HitTest )
+{
+    BOOL gray;
+    UINT DefItem;
+
+    gray = !(style & WS_THICKFRAME) || (style & (WS_MAXIMIZE | WS_MINIMIZE));
+    IntEnableMenuItem( menu, SC_SIZE, (gray ? MF_GRAYED : MF_ENABLED) );
+    gray = ((style & WS_MAXIMIZE) != 0);
+    IntEnableMenuItem( menu, SC_MOVE, (gray ? MF_GRAYED : MF_ENABLED) );
+    gray = !(style & WS_MINIMIZEBOX) || (style & WS_MINIMIZE);
+    IntEnableMenuItem( menu, SC_MINIMIZE, (gray ? MF_GRAYED : MF_ENABLED) );
+    gray = !(style & WS_MAXIMIZEBOX) || (style & WS_MAXIMIZE);
+    IntEnableMenuItem( menu, SC_MAXIMIZE, (gray ? MF_GRAYED : MF_ENABLED) );
+    gray = !(style & (WS_MAXIMIZE | WS_MINIMIZE));
+    IntEnableMenuItem( menu, SC_RESTORE, (gray ? MF_GRAYED : MF_ENABLED) );
+    gray = (clsStyle & CS_NOCLOSE) != 0;
+
+    /* The menu item must keep its state if it's disabled */
+    if(gray)
+        IntEnableMenuItem( menu, SC_CLOSE, MF_GRAYED);
+
+    /* Set default menu item */
+    if(style & WS_MINIMIZE) DefItem = SC_RESTORE;
+    else if(HitTest == HTCAPTION) DefItem = ((style & (WS_MAXIMIZE | WS_MINIMIZE)) ? SC_RESTORE : SC_MAXIMIZE);
+    else DefItem = SC_CLOSE;
+
+    UserSetMenuDefaultItem(menu, DefItem, MF_BYCOMMAND);
+}
+
+
+/***********************************************************************
+ *           MenuDrawPopupGlyph
+ *
+ * Draws popup magic glyphs (can be found in system menu).
+ */
+static void FASTCALL
+MENU_DrawPopupGlyph(HDC dc, LPRECT r, INT_PTR popupMagic, BOOL inactive, BOOL hilite)
+{
+  LOGFONTW lf;
+  HFONT hFont, hOldFont;
+  COLORREF clrsave;
+  INT bkmode;
+  WCHAR symbol;
+  switch (popupMagic)
+  {
+  case (INT_PTR) HBMMENU_POPUP_RESTORE:
+    symbol = '2';
+    break;
+  case (INT_PTR) HBMMENU_POPUP_MINIMIZE:
+    symbol = '0';
+    break;
+  case (INT_PTR) HBMMENU_POPUP_MAXIMIZE:
+    symbol = '1';
+    break;
+  case (INT_PTR) HBMMENU_POPUP_CLOSE:
+    symbol = 'r';
+    break;
+  default:
+    ERR("Invalid popup magic bitmap %d\n", (int)popupMagic);
+    return;
+  }
+  RtlZeroMemory(&lf, sizeof(LOGFONTW));
+  RECTL_vInflateRect(r, -2, -2);
+  lf.lfHeight = r->bottom - r->top;
+  lf.lfWidth = 0;
+  lf.lfWeight = FW_NORMAL;
+  lf.lfCharSet = DEFAULT_CHARSET;
+  RtlCopyMemory(lf.lfFaceName, L"Marlett", sizeof(L"Marlett"));
+  hFont = GreCreateFontIndirectW(&lf);
+  /* save font and text color */
+  hOldFont = NtGdiSelectFont(dc, hFont);
+  clrsave = GreGetTextColor(dc);
+  bkmode = GreGetBkMode(dc);
+  /* set color and drawing mode */
+  IntGdiSetBkMode(dc, TRANSPARENT);
+  if (inactive)
+  {
+    /* draw shadow */
+    if (!hilite)
+    {
+      IntGdiSetTextColor(dc, IntGetSysColor(COLOR_HIGHLIGHTTEXT));
+      GreTextOutW(dc, r->left + 1, r->top + 1, &symbol, 1);
+    }
+  }
+  IntGdiSetTextColor(dc, IntGetSysColor(inactive ? COLOR_GRAYTEXT : (hilite ? COLOR_HIGHLIGHTTEXT : COLOR_MENUTEXT)));
+  /* draw selected symbol */
+  GreTextOutW(dc, r->left, r->top, &symbol, 1);
+  /* restore previous settings */
+  IntGdiSetTextColor(dc, clrsave);
+  NtGdiSelectFont(dc, hOldFont);
+  IntGdiSetBkMode(dc, bkmode);
+  GreDeleteObject(hFont);
+}
+
+/***********************************************************************
+ *           MENU_AdjustMenuItemRect
+ *
+ * Adjust menu item rectangle according to scrolling state.
+ */
 VOID FASTCALL
+MENU_AdjustMenuItemRect(PMENU menu, PRECTL rect)
+{
+    if (menu->dwArrowsOn)
+    {
+        UINT arrow_bitmap_height;
+        arrow_bitmap_height = gpsi->oembmi[OBI_UPARROW].cy; ///// Menu up arrow! OBM_UPARROW
+        rect->top += arrow_bitmap_height - menu->iTop;
+        rect->bottom += arrow_bitmap_height - menu->iTop;
+    }
+}
+
+/***********************************************************************
+ *           MENU_FindItemByCoords
+ *
+ * Find the item at the specified coordinates (screen coords). Does
+ * not work for child windows and therefore should not be called for
+ * an arbitrary system menu.
+ */
+//static
+ITEM *MENU_FindItemByCoords( MENU *menu, POINT pt, UINT *pos )
+{
+    ITEM *item;
+    UINT i;
+    RECT rect;
+    PWND pWnd = ValidateHwndNoErr(menu->hWnd);
+
+    if (!IntGetWindowRect(pWnd, &rect)) return NULL;
+    if (pWnd->ExStyle & WS_EX_LAYOUTRTL)
+       pt.x = rect.right - 1 - pt.x;
+    else
+       pt.x -= rect.left;
+    pt.y -= rect.top;
+    item = menu->rgItems;
+    for (i = 0; i < menu->cItems; i++, item++)
+    {
+        //rect = item->rect;
+        rect.left   = item->xItem;
+        rect.top    = item->yItem; 
+        rect.right  = item->cxItem; // Do this for now......
+        rect.bottom = item->cyItem;
+
+        MENU_AdjustMenuItemRect(menu, &rect);
+	if (RECTL_bPointInRect(&rect, pt.x, pt.y))
+	{
+	    if (pos) *pos = i;
+	    return item;
+	}
+    }
+    return NULL;
+}
+
+INT FASTCALL IntMenuItemFromPoint(PWND pWnd, HMENU hMenu, POINT ptScreen)
+{
+    MENU *menu = UserGetMenuObject(hMenu);
+    UINT pos;
+
+    /*FIXME: Do we have to handle hWnd here? */
+    if (!menu) return -1;
+    if (!MENU_FindItemByCoords(menu, ptScreen, &pos)) return -1;
+    return pos;
+}
+
+/***********************************************************************
+ *           MenuFindItemByKey
+ *
+ * Find the menu item selected by a key press.
+ * Return item id, -1 if none, -2 if we should close the menu.
+ */
+//static
+UINT FASTCALL MENU_FindItemByKey(PWND WndOwner, PMENU menu,
+                  WCHAR Key, BOOL ForceMenuChar)
+{
+  LRESULT MenuChar;
+  WORD Flags = 0;
+
+  TRACE("\tlooking for '%c' (0x%02x) in [%p]\n", (char)Key, Key, menu );
+
+  if (!menu || !VerifyMenu(menu))
+     menu = co_IntGetSubMenu( UserGetMenuObject(WndOwner->SystemMenu), 0 );
+  if (menu)
+  {
+     ITEM *item = menu->rgItems;
+
+     if ( !ForceMenuChar )
+     {
+        UINT i;
+        BOOL cjk = UserGetSystemMetrics( SM_DBCSENABLED );
+
+        for (i = 0; i < menu->cItems; i++, item++)
+        {
+           LPWSTR text = item->Xlpstr;
+           if( text)
+           {
+              const WCHAR *p = text - 2;
+              do
+              {
+                 const WCHAR *q = p + 2;
+                 p = wcschr (q, '&');
+                 if (!p && cjk) p = wcschr (q, '\036'); /* Japanese Win16 */
+              }
+              while (p != NULL && p [1] == '&');
+              if (p && (towupper(p[1]) == towupper(Key))) return i;
+           }
+        }
+     }
+
+     Flags |= menu->fFlags & MNF_POPUP ? MF_POPUP : 0;
+     Flags |= menu->fFlags & MNF_SYSMENU ? MF_SYSMENU : 0;
+
+     MenuChar = co_IntSendMessage( UserHMGetHandle(WndOwner), WM_MENUCHAR,
+                              MAKEWPARAM(Key, Flags), (LPARAM) UserHMGetHandle(menu));
+     if (HIWORD(MenuChar) == MNC_EXECUTE) return LOWORD(MenuChar);
+     if (HIWORD(MenuChar) == MNC_CLOSE) return (UINT)(-2);
+  }
+  return (UINT)(-1);
+}
+
+/***********************************************************************
+ *           MenuGetBitmapItemSize
+ *
+ * Get the size of a bitmap item.
+ */
+static void FASTCALL MENU_GetBitmapItemSize(PITEM lpitem, SIZE *size, PWND WndOwner)
+{
+    BITMAP bm;
+    HBITMAP bmp = lpitem->hbmp;
+
+    size->cx = size->cy = 0;
+
+    /* check if there is a magic menu item associated with this item */
+    if (IS_MAGIC_BITMAP(bmp))
+    {
+      switch((INT_PTR) bmp)
+        {
+            case (INT_PTR)HBMMENU_CALLBACK:
+            {
+                MEASUREITEMSTRUCT measItem;
+                measItem.CtlType = ODT_MENU;
+                measItem.CtlID = 0;
+                measItem.itemID = lpitem->wID;
+                measItem.itemWidth = lpitem->cxItem - lpitem->xItem; //lpitem->Rect.right - lpitem->Rect.left;
+                measItem.itemHeight = lpitem->cyItem - lpitem->yItem;//lpitem->Rect.bottom - lpitem->Rect.top;
+                measItem.itemData = lpitem->dwItemData;
+                co_IntSendMessage( UserHMGetHandle(WndOwner), WM_MEASUREITEM, lpitem->wID, (LPARAM)&measItem);
+                size->cx = measItem.itemWidth;
+                size->cy = measItem.itemHeight;
+                return;
+            }
+            break;
+
+          case (INT_PTR) HBMMENU_SYSTEM:
+            if (lpitem->dwItemData)
+              {
+                bmp = (HBITMAP) lpitem->dwItemData;
+                break;
+              }
+            /* fall through */
+          case (INT_PTR) HBMMENU_MBAR_RESTORE:
+          case (INT_PTR) HBMMENU_MBAR_MINIMIZE:
+          case (INT_PTR) HBMMENU_MBAR_CLOSE:
+          case (INT_PTR) HBMMENU_MBAR_MINIMIZE_D:
+          case (INT_PTR) HBMMENU_MBAR_CLOSE_D:
+          case (INT_PTR) HBMMENU_POPUP_CLOSE:
+          case (INT_PTR) HBMMENU_POPUP_RESTORE:
+          case (INT_PTR) HBMMENU_POPUP_MAXIMIZE:
+          case (INT_PTR) HBMMENU_POPUP_MINIMIZE:
+            /* FIXME: Why we need to subtract these magic values? */
+            /* to make them smaller than the menu bar? */
+            size->cx = UserGetSystemMetrics(SM_CXSIZE) - 2;
+            size->cy = UserGetSystemMetrics(SM_CYSIZE) - 4;
+            return;
+        }
+    }
+
+    if (GreGetObject(bmp, sizeof(BITMAP), &bm))
+    {
+        size->cx = bm.bmWidth;
+        size->cy = bm.bmHeight;
+    }
+}
+
+/***********************************************************************
+ *           MenuDrawBitmapItem
+ *
+ * Draw a bitmap item.
+ */
+static void FASTCALL MENU_DrawBitmapItem(HDC hdc, PITEM lpitem, const RECT *rect,
+                    PMENU Menu, PWND WndOwner, UINT odaction, BOOL MenuBar)
+{
+    BITMAP bm;
+    DWORD rop;
+    HDC hdcMem;
+    HBITMAP bmp;
+    int w = rect->right - rect->left;
+    int h = rect->bottom - rect->top;
+    int bmp_xoffset = 0;
+    int left, top;
+    HBITMAP hbmToDraw = lpitem->hbmp;
+    bmp = hbmToDraw;
+
+    /* Check if there is a magic menu item associated with this item */
+    if (IS_MAGIC_BITMAP(hbmToDraw))
+    {
+        UINT flags = 0;
+        RECT r;
+
+      r = *rect;
+      switch ((INT_PTR)hbmToDraw)
+      {
+        case (INT_PTR)HBMMENU_SYSTEM:
+            if (lpitem->dwItemData)
+            {
+                bmp = (HBITMAP)lpitem->dwItemData;
+                if (!GreGetObject( bmp, sizeof(bm), &bm )) return;
+            }
+            else
+            {
+                PCURICON_OBJECT pIcon = NULL;
+                //if (!BmpSysMenu) BmpSysMenu = LoadBitmapW(0, MAKEINTRESOURCEW(OBM_CLOSE));
+                //bmp = BmpSysMenu;
+                //if (! GreGetObject(bmp, sizeof(bm), &bm)) return;
+                /* only use right half of the bitmap */
+                //bmp_xoffset = bm.bmWidth / 2;
+                //bm.bmWidth -= bmp_xoffset;
+                if (WndOwner)
+                {
+                    pIcon = NC_IconForWindow(WndOwner);
+                    // FIXME: NC_IconForWindow should reference it for us */
+                    if (pIcon) UserReferenceObject(pIcon);
+                }
+
+                if (pIcon)
+                {
+                   LONG cx = UserGetSystemMetrics(SM_CXSMICON);
+                   LONG cy = UserGetSystemMetrics(SM_CYSMICON);
+                   LONG x = rect->left - cx/2 + 1 + (rect->bottom - rect->top)/2; // this is really what Window does
+                   LONG y = (rect->top + rect->bottom)/2 - cy/2; // center
+                   UserDrawIconEx(hdc, x, y, pIcon, cx, cy, 0, NULL, DI_NORMAL);
+                   UserDereferenceObject(pIcon);
+                 }
+                 return;
+            }
+            goto got_bitmap;
+        case (INT_PTR)HBMMENU_MBAR_RESTORE:
+            flags = DFCS_CAPTIONRESTORE;
+            break;
+        case (INT_PTR)HBMMENU_MBAR_MINIMIZE:
+            r.right += 1;
+            flags = DFCS_CAPTIONMIN;
+            break;
+        case (INT_PTR)HBMMENU_MBAR_MINIMIZE_D:
+            r.right += 1;
+            flags = DFCS_CAPTIONMIN | DFCS_INACTIVE;
+            break;
+        case (INT_PTR)HBMMENU_MBAR_CLOSE:
+            flags = DFCS_CAPTIONCLOSE;
+            break;
+        case (INT_PTR)HBMMENU_MBAR_CLOSE_D:
+            flags = DFCS_CAPTIONCLOSE | DFCS_INACTIVE;
+            break;
+        case (INT_PTR)HBMMENU_CALLBACK:
+            {
+                DRAWITEMSTRUCT drawItem;
+                POINT origorg;
+                drawItem.CtlType = ODT_MENU;
+                drawItem.CtlID = 0;
+                drawItem.itemID = lpitem->wID;
+                drawItem.itemAction = odaction;
+                drawItem.itemState = (lpitem->fState & MF_CHECKED)?ODS_CHECKED:0;
+                drawItem.itemState |= (lpitem->fState & MF_DEFAULT)?ODS_DEFAULT:0;
+                drawItem.itemState |= (lpitem->fState & MF_DISABLED)?ODS_DISABLED:0;
+                drawItem.itemState |= (lpitem->fState & MF_GRAYED)?ODS_GRAYED|ODS_DISABLED:0;
+                drawItem.itemState |= (lpitem->fState & MF_HILITE)?ODS_SELECTED:0;
+                drawItem.itemState |= (!(Menu->fFlags & MNF_UNDERLINE))?ODS_NOACCEL:0;
+                drawItem.itemState |= (Menu->fFlags & MNF_INACTIVE)?ODS_INACTIVE:0;
+                drawItem.hwndItem = (HWND)UserHMGetHandle(Menu);
+                drawItem.hDC = hdc;
+                drawItem.rcItem = *rect;
+                drawItem.itemData = lpitem->dwItemData;
+                /* some applications make this assumption on the DC's origin */
+                GreSetViewportOrgEx( hdc, lpitem->xItem, lpitem->yItem, &origorg);
+                RECTL_vOffsetRect( &drawItem.rcItem, - lpitem->xItem, - lpitem->yItem);
+                co_IntSendMessage( UserHMGetHandle(WndOwner), WM_DRAWITEM, 0, (LPARAM)&drawItem);
+                GreSetViewportOrgEx( hdc, origorg.x, origorg.y, NULL);
+                return;
+            }
+            break;
+
+          case (INT_PTR) HBMMENU_POPUP_CLOSE:
+          case (INT_PTR) HBMMENU_POPUP_RESTORE:
+          case (INT_PTR) HBMMENU_POPUP_MAXIMIZE:
+          case (INT_PTR) HBMMENU_POPUP_MINIMIZE:
+            MENU_DrawPopupGlyph(hdc, &r, (INT_PTR)hbmToDraw, lpitem->fState & MF_GRAYED, lpitem->fState & MF_HILITE);
+            return;
+      }
+      RECTL_vInflateRect(&r, -1, -1);
+      if (lpitem->fState & MF_HILITE) flags |= DFCS_PUSHED;
+      DrawFrameControl(hdc, &r, DFC_CAPTION, flags);
+      return;
+    }
+
+    if (!bmp || !GreGetObject( bmp, sizeof(bm), &bm )) return;
+
+ got_bitmap:
+    hdcMem = NtGdiCreateCompatibleDC( hdc );
+    NtGdiSelectBitmap( hdcMem, bmp );
+
+    /* handle fontsize > bitmap_height */
+    top = (h>bm.bmHeight) ? rect->top+(h-bm.bmHeight)/2 : rect->top;
+    left=rect->left;
+    rop=((lpitem->fState & MF_HILITE) && !IS_MAGIC_BITMAP(hbmToDraw)) ? NOTSRCCOPY : SRCCOPY;
+    if ((lpitem->fState & MF_HILITE) && lpitem->hbmp)
+        IntGdiSetBkColor(hdc, IntGetSysColor(COLOR_HIGHLIGHT));
+    NtGdiBitBlt( hdc, left, top, w, h, hdcMem, bmp_xoffset, 0, rop , 0, 0);
+    IntGdiDeleteDC( hdcMem, FALSE );
+}
+
+DWORD FASTCALL IntGetCharDimensions(HDC hdc, PTEXTMETRICW ptm, PDWORD height);
+
+LONG
+IntGetDialogBaseUnits(VOID)
+{
+    static DWORD units;
+
+    if (!units)
+    {
+        HDC hdc;
+        SIZE size;
+
+        if ((hdc = UserGetDCEx(NULL, NULL, DCX_CACHE)))
+        {
+            size.cx = IntGetCharDimensions( hdc, NULL, (PDWORD)&size.cy );
+            if (size.cx) units = MAKELONG( size.cx, size.cy );
+            UserReleaseDC( 0, hdc, FALSE);
+        }
+    }
+    return units;
+}
+
+
+/***********************************************************************
+ *           MenuCalcItemSize
+ *
+ * Calculate the size of the menu item and store it in lpitem->rect.
+ */
+static void FASTCALL MENU_CalcItemSize( HDC hdc, PITEM lpitem, PMENU Menu, PWND pwndOwner,
+                 INT orgX, INT orgY, BOOL menuBar, BOOL textandbmp)
+{
+    WCHAR *p;
+    UINT check_bitmap_width = UserGetSystemMetrics( SM_CXMENUCHECK );
+    UINT arrow_bitmap_width;
+    RECT Rect;
+    INT itemheight = 0;
+
+    TRACE("dc=%x owner=%x (%d,%d)\n", hdc, pwndOwner, orgX, orgY);
+
+    arrow_bitmap_width = gpsi->oembmi[OBI_MNARROW].cx;
+
+    MenuCharSize.cx = IntGetCharDimensions( hdc, NULL, (PDWORD)&MenuCharSize.cy );
+
+    RECTL_vSetRect( &Rect, orgX, orgY, orgX, orgY );
+
+    if (lpitem->fType & MF_OWNERDRAW)
+    {
+        MEASUREITEMSTRUCT mis;
+        mis.CtlType    = ODT_MENU;
+        mis.CtlID      = 0;
+        mis.itemID     = lpitem->wID;
+        mis.itemData   = lpitem->dwItemData;
+        mis.itemHeight = HIWORD( IntGetDialogBaseUnits());
+        mis.itemWidth  = 0;
+        co_IntSendMessage( UserHMGetHandle(pwndOwner), WM_MEASUREITEM, 0, (LPARAM)&mis );
+        /* Tests reveal that Windows ( Win95 thru WinXP) adds twice the average
+         * width of a menufont character to the width of an owner-drawn menu. 
+         */
+        Rect.right += mis.itemWidth + 2 * MenuCharSize.cx;
+        if (menuBar) {
+            /* under at least win95 you seem to be given a standard
+               height for the menu and the height value is ignored */
+            Rect.bottom += UserGetSystemMetrics(SM_CYMENUSIZE);
+        } else
+            Rect.bottom += mis.itemHeight;
+        // Or this,
+        lpitem->cxBmp = mis.itemWidth;
+        lpitem->cyBmp = mis.itemHeight;
+        ERR("id=%04lx size=%dx%d cx %d cy %d\n",
+                lpitem->wID, Rect.right-Rect.left,
+                 Rect.bottom-Rect.top, MenuCharSize.cx, MenuCharSize.cy);
+/*
+        lpitem->xItem = Rect.left;
+        lpitem->yItem = Rect.top;
+        lpitem->cxItem = Rect.right;
+        lpitem->cyItem = Rect.bottom;
+ */
+        return;
+    }
+
+    lpitem->xItem  = orgX;
+    lpitem->yItem  = orgY; 
+    lpitem->cxItem = orgX;
+    lpitem->cyItem = orgY;
+
+    if (lpitem->fType & MF_SEPARATOR)
+    {
+        lpitem->cyItem += UserGetSystemMetrics( SM_CYMENUSIZE)/2;//SEPARATOR_HEIGHT;
+        if( !menuBar)
+            lpitem->cxItem += arrow_bitmap_width/*check_bitmap_width*/ + MenuCharSize.cx;
+        return;
+    }
+
+    lpitem->dxTab = 0;
+
+    if (lpitem->hbmp)
+    {
+        SIZE size;
+
+        if (!menuBar) {
+            MENU_GetBitmapItemSize(lpitem, &size, pwndOwner );
+            /* Keep the size of the bitmap in callback mode to be able
+             * to draw it correctly */
+            lpitem->cxBmp = size.cx;
+            lpitem->cyBmp = size.cy;
+            Menu->cxTextAlign = max(Menu->cxTextAlign, size.cx);
+
+            lpitem->cxItem += size.cx + 2;
+            itemheight = size.cy + 2;
+
+            if( !((Menu->fFlags & MNS_STYLE_MASK) & MNS_NOCHECK))
+                lpitem->cxItem += 2 * check_bitmap_width;
+            lpitem->cxItem += 4 + MenuCharSize.cx;
+            lpitem->dxTab = lpitem->cxItem;
+            lpitem->cxItem += arrow_bitmap_width;//check_bitmap_width;
+        } else /* hbmpItem & MenuBar */ {
+            MENU_GetBitmapItemSize(lpitem, &size, pwndOwner );
+            lpitem->cxItem  += size.cx;
+            if( lpitem->Xlpstr) lpitem->cxItem  += 2;
+            itemheight = size.cy;
+
+            /* Special case: Minimize button doesn't have a space behind it. */
+            if (lpitem->hbmp == (HBITMAP)HBMMENU_MBAR_MINIMIZE ||
+                lpitem->hbmp == (HBITMAP)HBMMENU_MBAR_MINIMIZE_D)
+            lpitem->cxItem -= 1;
+        }
+    }
+    else if (!menuBar) {
+        if( !((Menu->fFlags & MNS_STYLE_MASK) & MNS_NOCHECK))
+             lpitem->cxItem += check_bitmap_width;
+        lpitem->cxItem += 4 + MenuCharSize.cx;
+        lpitem->dxTab = lpitem->cxItem;
+        lpitem->cxItem += check_bitmap_width;
+    }
+
+    /* it must be a text item - unless it's the system menu */
+    if (!(lpitem->fType & MF_SYSMENU) && lpitem->Xlpstr) {
+        HFONT hfontOld = NULL;
+        RECT rc;// = lpitem->Rect;
+        LONG txtheight, txtwidth;
+
+        rc.left   = lpitem->xItem;
+        rc.top    = lpitem->yItem; 
+        rc.right  = lpitem->cxItem; // Do this for now......
+        rc.bottom = lpitem->cyItem;
+
+        if ( lpitem->fState & MFS_DEFAULT ) {
+            hfontOld = NtGdiSelectFont( hdc, ghMenuFontBold );
+        }
+        if (menuBar) {
+            txtheight = DrawTextW( hdc, lpitem->Xlpstr, -1, &rc, DT_SINGLELINE|DT_CALCRECT); 
+
+            lpitem->cxItem  += rc.right - rc.left;
+            itemheight = max( max( itemheight, txtheight), UserGetSystemMetrics( SM_CYMENU) - 1);
+
+            lpitem->cxItem +=  2 * MenuCharSize.cx;
+        } else {
+            if ((p = wcschr( lpitem->Xlpstr, '\t' )) != NULL) {
+                RECT tmprc = rc;
+                LONG tmpheight;
+                int n = (int)( p - lpitem->Xlpstr);
+                /* Item contains a tab (only meaningful in popup menus) */
+                /* get text size before the tab */
+                txtheight = DrawTextW( hdc, lpitem->Xlpstr, n, &rc,
+                        DT_SINGLELINE|DT_CALCRECT);
+                txtwidth = rc.right - rc.left;
+                p += 1; /* advance past the Tab */
+                /* get text size after the tab */
+                tmpheight = DrawTextW( hdc, p, -1, &tmprc,
+                        DT_SINGLELINE|DT_CALCRECT);
+                lpitem->dxTab += txtwidth;
+                txtheight = max( txtheight, tmpheight);
+                txtwidth += MenuCharSize.cx + /* space for the tab */
+                    tmprc.right - tmprc.left; /* space for the short cut */
+            } else {
+                txtheight = DrawTextW( hdc, lpitem->Xlpstr, -1, &rc,
+                        DT_SINGLELINE|DT_CALCRECT);
+                txtwidth = rc.right - rc.left;
+                lpitem->dxTab += txtwidth;
+            }
+            lpitem->cxItem  += 2 + txtwidth;
+            itemheight = max( itemheight,
+				    max( txtheight + 2, MenuCharSize.cy + 4));
+        }
+        if (hfontOld) NtGdiSelectFont (hdc, hfontOld);
+    } else if( menuBar) {
+        itemheight = max( itemheight, UserGetSystemMetrics(SM_CYMENU)-1);
+    }
+    lpitem->cyItem += itemheight;
+    TRACE("(%ld,%ld)-(%ld,%ld)\n", lpitem->xItem, lpitem->yItem, lpitem->cxItem, lpitem->cyItem);
+}
+
+/***********************************************************************
+ *           MENU_GetMaxPopupHeight
+ */
+static UINT
+MENU_GetMaxPopupHeight(PMENU lppop)
+{
+    if (lppop->cyMax)
+    {
+       //ERR("MGMaxPH cyMax %d\n",lppop->cyMax);
+       return lppop->cyMax;
+    }
+    //ERR("MGMaxPH SyMax %d\n",UserGetSystemMetrics(SM_CYSCREEN) - UserGetSystemMetrics(SM_CYBORDER));
+    return UserGetSystemMetrics(SM_CYSCREEN) - UserGetSystemMetrics(SM_CYBORDER);
+}
+
+/***********************************************************************
+ *           MenuPopupMenuCalcSize
+ *
+ * Calculate the size of a popup menu.
+ */
+//static
+void FASTCALL MENU_PopupMenuCalcSize(PMENU Menu, PWND WndOwner)
+{
+    PITEM lpitem;
+    HDC hdc;
+    int start, i;
+    int orgX, orgY, maxX, maxTab, maxTabWidth, maxHeight;
+    BOOL textandbmp = FALSE;
+
+    Menu->cxMenu = Menu->cyMenu = 0;
+    if (Menu->cItems == 0) return;
+
+    hdc = UserGetDCEx(NULL, NULL, DCX_CACHE);
+    NtGdiSelectFont( hdc, ghMenuFont );
+
+    start = 0;
+    maxX = 2 + 1;
+
+    Menu->cxTextAlign = 0;
+
+    while (start < Menu->cItems)
+    {
+      lpitem = &Menu->rgItems[start];
+      orgX = maxX;
+      //if( lpitem->fType & (MF_MENUBREAK | MF_MENUBARBREAK))
+      //    orgX += MENU_COL_SPACE;
+      orgY = MENU_TOP_MARGIN;
+
+      maxTab = maxTabWidth = 0;
+      /* Parse items until column break or end of menu */
+      for (i = start; i < Menu->cItems; i++)//, lpitem++)
+      {
+          if (i != start &&
+               (lpitem->fType & (MF_MENUBREAK | MF_MENUBARBREAK))) break;
+
+          MENU_CalcItemSize(hdc, lpitem, Menu, WndOwner, orgX, orgY, FALSE, textandbmp);
+          maxX = max(maxX, lpitem->cxItem);
+          orgY = lpitem->cyItem;
+          if (IS_STRING_ITEM(lpitem->fType) && lpitem->dxTab )
+          {
+              maxTab = max( maxTab, lpitem->dxTab );
+              maxTabWidth = max(maxTabWidth, lpitem->cxItem - lpitem->dxTab);
+          }
+          if( lpitem->Xlpstr && lpitem->hbmp) textandbmp = TRUE;
+      }
+
+        /* Finish the column (set all items to the largest width found) */
+      maxX = max( maxX, maxTab + maxTabWidth );
+      for (lpitem = &Menu->rgItems[start]; start < i; start++, lpitem++)
+      {
+          lpitem->cxItem = maxX;
+           if (IS_STRING_ITEM(lpitem->fType) && lpitem->dxTab)
+               lpitem->dxTab = maxTab;
+      }
+      Menu->cyMenu = max(Menu->cyMenu, orgY);
+    }
+
+    Menu->cxMenu  = maxX;
+    /* if none of the items have both text and bitmap then
+     * the text and bitmaps are all aligned on the left. If there is at
+     * least one item with both text and bitmap then bitmaps are
+     * on the left and texts left aligned with the right hand side
+     * of the bitmaps */
+    if( !textandbmp) Menu->cxTextAlign = 0;
+
+    /* space for 3d border */
+    Menu->cyMenu += MENU_BOTTOM_MARGIN;
+    Menu->cxMenu += 2;
+
+    /* Adjust popup height if it exceeds maximum */
+    maxHeight = MENU_GetMaxPopupHeight(Menu);
+    Menu->iMaxTop = Menu->cyMenu - MENU_TOP_MARGIN;
+    if (Menu->cyMenu >= maxHeight)
+    {
+       Menu->cyMenu = maxHeight;
+       Menu->dwArrowsOn = 1;
+    }
+    else
+    {   
+       Menu->dwArrowsOn = 0;
+    }
+
+    UserReleaseDC( 0, hdc, FALSE );
+}
+
+/***********************************************************************
+ *           MENU_MenuBarCalcSize
+ *
+ * FIXME: Word 6 implements its own MDI and its own 'close window' bitmap
+ * height is off by 1 pixel which causes lengthy window relocations when
+ * active document window is maximized/restored.
+ *
+ * Calculate the size of the menu bar.
+ */
+static void MENU_MenuBarCalcSize( HDC hdc, LPRECT lprect, PMENU lppop, PWND pwndOwner )
+{
+    ITEM *lpitem;
+    UINT start, i, helpPos;
+    int orgX, orgY, maxY;
+
+    if ((lprect == NULL) || (lppop == NULL)) return;
+    if (lppop->cItems == 0) return;
+    //TRACE("lprect %p %s\n", lprect, wine_dbgstr_rect( lprect));
+    lppop->cxMenu  = lprect->right - lprect->left;
+    lppop->cyMenu = 0;
+    maxY = lprect->top+1;
+    start = 0;
+    helpPos = ~0U;
+    lppop->cxTextAlign = 0;
+    while (start < lppop->cItems)
+    {
+	lpitem = &lppop->rgItems[start];
+	orgX = lprect->left;
+	orgY = maxY;
+
+	  /* Parse items until line break or end of menu */
+	for (i = start; i < lppop->cItems; i++, lpitem++)
+	{
+	    if ((helpPos == ~0U) && (lpitem->fType & MF_RIGHTJUSTIFY)) helpPos = i;
+	    if ((i != start) &&
+		(lpitem->fType & (MF_MENUBREAK | MF_MENUBARBREAK))) break;
+
+	    TRACE("calling MENU_CalcItemSize org=(%d, %d)\n", orgX, orgY );
+	    //debug_print_menuitem ("  item: ", lpitem, "");
+	    //MENU_CalcItemSize( hdc, lpitem, pwndOwner, orgX, orgY, TRUE, lppop );
+            MENU_CalcItemSize(hdc, lpitem, lppop, pwndOwner, orgX, orgY, TRUE, FALSE);
+
+	    if (lpitem->cxItem > lprect->right)
+	    {
+		if (i != start) break;
+		else lpitem->cxItem = lprect->right;
+	    }
+	    maxY = max( maxY, lpitem->cyItem );
+	    orgX = lpitem->cxItem;
+	}
+
+	  /* Finish the line (set all items to the largest height found) */
+	while (start < i) lppop->rgItems[start++].cyItem = maxY;
+    }
+
+    lprect->bottom = maxY;
+    lppop->cyMenu = lprect->bottom - lprect->top;
+
+    /* Flush right all items between the MF_RIGHTJUSTIFY and */
+    /* the last item (if several lines, only move the last line) */
+    if (helpPos == ~0U) return;
+    lpitem = &lppop->rgItems[lppop->cItems-1];
+    orgY = lpitem->yItem;
+    orgX = lprect->right;
+    for (i = lppop->cItems - 1; i >= helpPos; i--, lpitem--) {
+        if (lpitem->yItem != orgY) break;	/* Other line */
+        if (lpitem->cxItem >= orgX) break;	/* Too far right already */
+        lpitem->xItem += orgX - lpitem->cxItem;
+        lpitem->cxItem = orgX;
+        orgX = lpitem->xItem;
+    }
+}
+
+/***********************************************************************
+ *           MENU_DrawScrollArrows
+ *
+ * Draw scroll arrows.
+ */
+static void
+MENU_DrawScrollArrows(PMENU lppop, HDC hdc)
+{
+    //HDC hdcMem = NtGdiCreateCompatibleDC(hdc);
+    //HBITMAP hOrigBitmap;
+    UINT arrow_bitmap_width, arrow_bitmap_height;
+    //BITMAP bmp;
+    RECT rect, dfcrc;
+
+    //GreGetObject(get_down_arrow_bitmap(), sizeof(bmp), &bmp);
+    arrow_bitmap_width  = gpsi->oembmi[OBI_DNARROW].cx;
+    arrow_bitmap_height = gpsi->oembmi[OBI_DNARROW].cy;
+
+/*    if (lppop->iTop)
+        hOrigBitmap = SelectObject(hdcMem, get_up_arrow_bitmap());
+    else
+        hOrigBitmap = SelectObject(hdcMem, get_up_arrow_inactive_bitmap());
+*/
+    rect.left = 0;
+    rect.top = 0;
+    rect.right = lppop->cxMenu;
+    rect.bottom = arrow_bitmap_height;
+    FillRect(hdc, &rect, IntGetSysColorBrush(COLOR_MENU));
+/*
+    NtGdiBitBlt(hdc, (lppop->cxMenu - arrow_bitmap_width) / 2, 0,
+           arrow_bitmap_width, arrow_bitmap_height, hdcMem, 0, 0, SRCCOPY, 0,0);
+ */
+    dfcrc.left = (lppop->cxMenu - arrow_bitmap_width) / 2;
+    dfcrc.top = 0;
+    dfcrc.right = arrow_bitmap_width;
+    dfcrc.bottom = arrow_bitmap_height;
+    DrawFrameControl(hdc, &dfcrc, DFC_MENU, (lppop->iTop ? 0 : DFCS_INACTIVE)|DFCS_MENUARROWUP);
+
+    rect.top = lppop->cyMenu - arrow_bitmap_height;
+    rect.bottom = lppop->cyMenu;
+
+    FillRect(hdc, &rect, IntGetSysColorBrush(COLOR_MENU));
+/*
+    if (lppop->iTop < lppop->iMaxTop - (MENU_GetMaxPopupHeight(lppop) - 2 * arrow_bitmap_height))
+        SelectObject(hdcMem, get_down_arrow_bitmap());
+    else
+        SelectObject(hdcMem, get_down_arrow_inactive_bitmap());
+    NtGdiBitBlt(hdc, (lppop->cxMenu - arrow_bitmap_width) / 2,
+           lppop->cyMenu - arrow_bitmap_height,
+           arrow_bitmap_width, arrow_bitmap_height, hdcMem, 0, 0, SRCCOPY, 0,0);
+ */
+    dfcrc.left = (lppop->cxMenu - arrow_bitmap_width) / 2;
+    dfcrc.top = lppop->cyMenu - arrow_bitmap_height;
+    dfcrc.right = arrow_bitmap_width;
+    dfcrc.bottom = arrow_bitmap_height;
+    DrawFrameControl(hdc, &dfcrc, DFC_MENU,
+       ((lppop->iTop < lppop->iMaxTop - (MENU_GetMaxPopupHeight(lppop) - 2 * arrow_bitmap_height)) ? 0 : DFCS_INACTIVE)|DFCS_MENUARROWDOWN);
+
+    //SelectObject(hdcMem, hOrigBitmap);
+    //IntGdiDeleteDC(hdcMem, FALSE);
+}
+
+/***********************************************************************
+ *           draw_popup_arrow
+ *
+ * Draws the popup-menu arrow.
+ */
+static void draw_popup_arrow( HDC hdc, RECT rect, UINT arrow_bitmap_width,
+        UINT arrow_bitmap_height)
+{
+    RECT dfcrc;
+    /*HDC hdcMem = NtGdiCreateCompatibleDC( hdc );
+    HBITMAP hOrigBitmap;
+
+    //hOrigBitmap = SelectObject( hdcMem, get_arrow_bitmap() );
+    NtGdiBitBlt( hdc, rect.right - arrow_bitmap_width - 1,
+            (rect.top + rect.bottom - arrow_bitmap_height) / 2,
+            arrow_bitmap_width, arrow_bitmap_height,
+            hdcMem, 0, 0, SRCCOPY, 0,0 );
+    SelectObject( hdcMem, hOrigBitmap );*/
+
+    dfcrc.left = rect.right - arrow_bitmap_width - 1;
+    dfcrc.top = (rect.top + rect.bottom - arrow_bitmap_height) / 2;
+    dfcrc.right = arrow_bitmap_width;
+    dfcrc.bottom = arrow_bitmap_height;    
+    DrawFrameControl(hdc, &dfcrc, DFC_MENU, DFCS_MENUARROW);
+    //IntGdiDeleteDC( hdcMem, FALSE );
+}
+
+/***********************************************************************
+ *           MenuDrawMenuItem
+ *
+ * Draw a single menu item.
+ */
+static void FASTCALL MENU_DrawMenuItem(PWND Wnd, PMENU Menu, PWND WndOwner, HDC hdc,
+                 PITEM lpitem, UINT Height, BOOL menuBar, UINT odaction)
+{
+    RECT rect;
+    PWCHAR Text;
+    BOOL flat_menu = FALSE;
+    int bkgnd;
+    UINT arrow_bitmap_width = 0, arrow_bitmap_height = 0;
+
+    if (!menuBar) {
+        arrow_bitmap_width  = gpsi->oembmi[OBI_MNARROW].cx; 
+        arrow_bitmap_height = gpsi->oembmi[OBI_MNARROW].cy;
+    }
+
+    if (lpitem->fType & MF_SYSMENU)
+    {
+        if ( (Wnd->style & WS_MINIMIZE))
+        {
+          UserGetInsideRectNC(Wnd, &rect);
+          UserDrawSysMenuButton(Wnd, hdc, &rect, lpitem->fState & (MF_HILITE | MF_MOUSESELECT));
+	}
+        return;
+    }
+
+    UserSystemParametersInfo (SPI_GETFLATMENU, 0, &flat_menu, 0);
+    bkgnd = (menuBar && flat_menu) ? COLOR_MENUBAR : COLOR_MENU;
+  
+    /* Setup colors */
+
+    if (lpitem->fState & MF_HILITE)
+    {
+        if(menuBar && !flat_menu) {
+            IntGdiSetTextColor(hdc, IntGetSysColor(COLOR_MENUTEXT));
+            IntGdiSetBkColor(hdc, IntGetSysColor(COLOR_MENU));
+        } else {
+            if (lpitem->fState & MF_GRAYED)
+                IntGdiSetTextColor(hdc, IntGetSysColor(COLOR_GRAYTEXT));
+            else
+                IntGdiSetTextColor(hdc, IntGetSysColor(COLOR_HIGHLIGHTTEXT));
+            IntGdiSetBkColor(hdc, IntGetSysColor(COLOR_HIGHLIGHT));
+        }
+    }
+    else
+    {
+        if (lpitem->fState & MF_GRAYED)
+            IntGdiSetTextColor( hdc, IntGetSysColor( COLOR_GRAYTEXT ) );
+        else
+            IntGdiSetTextColor( hdc, IntGetSysColor( COLOR_MENUTEXT ) );
+        IntGdiSetBkColor( hdc, IntGetSysColor( bkgnd ) );
+    }
+
+    //TRACE("rect=%s\n", wine_dbgstr_rect( &lpitem->Rect));
+    //rect = lpitem->Rect;
+    rect.left   = lpitem->xItem;
+    rect.top    = lpitem->yItem; 
+    rect.right  = lpitem->cxItem; // Do this for now......
+    rect.bottom = lpitem->cyItem;
+
+    MENU_AdjustMenuItemRect(Menu, &rect);
+
+    if (lpitem->fType & MF_OWNERDRAW)
+    {
+        /*
+        ** Experimentation under Windows reveals that an owner-drawn
+        ** menu is given the rectangle which includes the space it requested
+        ** in its response to WM_MEASUREITEM _plus_ width for a checkmark
+        ** and a popup-menu arrow.  This is the value of lpitem->rect.
+        ** Windows will leave all drawing to the application except for
+        ** the popup-menu arrow.  Windows always draws that itself, after
+        ** the menu owner has finished drawing.
+        */
+        DRAWITEMSTRUCT dis;
+
+        dis.CtlType   = ODT_MENU;
+        dis.CtlID     = 0;
+        dis.itemID    = lpitem->wID;
+        dis.itemData  = (DWORD)lpitem->dwItemData;
+        dis.itemState = 0;
+        if (lpitem->fState & MF_CHECKED)  dis.itemState |= ODS_CHECKED;
+        if (lpitem->fState & MF_DEFAULT)  dis.itemState |= ODS_DEFAULT;
+        if (lpitem->fState & MF_DISABLED) dis.itemState |= ODS_DISABLED;
+        if (lpitem->fState & MF_GRAYED)   dis.itemState |= ODS_GRAYED | ODS_DISABLED;
+        if (lpitem->fState & MF_HILITE)   dis.itemState |= ODS_SELECTED;
+        if (!(Menu->fFlags & MNF_UNDERLINE)) dis.itemState |= ODS_NOACCEL;
+        if (Menu->fFlags & MNF_INACTIVE) dis.itemState |= ODS_INACTIVE;
+        dis.itemAction = odaction; /* ODA_DRAWENTIRE | ODA_SELECT | ODA_FOCUS; */
+        dis.hwndItem   = (HWND) UserHMGetHandle(Menu);
+        dis.hDC        = hdc;
+        dis.rcItem     = rect;
+        TRACE("Ownerdraw: owner=%p itemID=%d, itemState=%d, itemAction=%d, "
+	        "hwndItem=%p, hdc=%p, rcItem={%ld,%ld,%ld,%ld}\n", Wnd,
+	        dis.itemID, dis.itemState, dis.itemAction, dis.hwndItem,
+	        dis.hDC, dis.rcItem.left, dis.rcItem.top, dis.rcItem.right,
+	        dis.rcItem.bottom);
+        co_IntSendMessage(UserHMGetHandle(WndOwner), WM_DRAWITEM, 0, (LPARAM) &dis);
+        /* Draw the popup-menu arrow */
+        if (lpitem->spSubMenu)
+        {
+           /* RECT rectTemp;
+            CopyRect(&rectTemp, &rect);
+            rectTemp.left = rectTemp.right - UserGetSystemMetrics(SM_CXMENUCHECK);
+            DrawFrameControl(hdc, &rectTemp, DFC_MENU, DFCS_MENUARROW);
+            */
+            draw_popup_arrow( hdc, rect, arrow_bitmap_width, arrow_bitmap_height);
+        }
+        return;
+    }
+
+    if (menuBar && (lpitem->fType & MF_SEPARATOR)) return;
+
+    if (lpitem->fState & MF_HILITE)
+    {
+        if (flat_menu)
+        {
+            RECTL_vInflateRect (&rect, -1, -1);
+            FillRect(hdc, &rect, IntGetSysColorBrush(COLOR_MENUHILIGHT));
+            RECTL_vInflateRect (&rect, 1, 1);
+            FrameRect(hdc, &rect, IntGetSysColorBrush(COLOR_HIGHLIGHT));
+        }
+        else
+        {
+            if(menuBar)
+                DrawEdge(hdc, &rect, BDR_SUNKENOUTER, BF_RECT);
+            else
+                FillRect(hdc, &rect, IntGetSysColorBrush(COLOR_HIGHLIGHT));
+        }
+    }
+    else
+        FillRect( hdc, &rect, IntGetSysColorBrush(bkgnd) );
+
+    IntGdiSetBkMode( hdc, TRANSPARENT );
+
+    /* vertical separator */
+    if (!menuBar && (lpitem->fType & MF_MENUBARBREAK))
+    {
+        HPEN oldPen;
+        RECT rc = rect;
+
+        rc.left -= 3;//MENU_COL_SPACE / 2 + 1;
+        rc.top = 3;
+        rc.bottom = Height - 3;
+        if (flat_menu)
+        {
+            oldPen = NtGdiSelectPen( hdc, NtGdiGetStockObject(DC_PEN) );
+            IntSetDCPenColor(hdc, IntGetSysColor(COLOR_BTNSHADOW));
+            GreMoveTo( hdc, rc.left, rc.top, NULL );
+            NtGdiLineTo( hdc, rc.left, rc.bottom );
+            NtGdiSelectPen( hdc, oldPen );
+        }
+        else
+            DrawEdge (hdc, &rc, EDGE_ETCHED, BF_LEFT);
+    }
+
+    /* horizontal separator */
+    if (lpitem->fType & MF_SEPARATOR)
+    {
+        HPEN oldPen;
+        RECT rc = rect;
+
+        rc.left++;
+        rc.right--;
+        rc.top += SEPARATOR_HEIGHT / 2;
+        if (flat_menu)
+        {
+            oldPen = NtGdiSelectPen( hdc, NtGdiGetStockObject(DC_PEN) );
+            IntSetDCPenColor( hdc, IntGetSysColor(COLOR_BTNSHADOW));
+            GreMoveTo( hdc, rc.left, rc.top, NULL );
+            NtGdiLineTo( hdc, rc.right, rc.top );
+            NtGdiSelectPen( hdc, oldPen );
+        }
+        else
+            DrawEdge (hdc, &rc, EDGE_ETCHED, BF_TOP);
+        return;
+    }
+
+#if 0
+    /* helper lines for debugging */
+    /* This is a very good test tool when hacking menus! (JT) 07/16/2006 */
+    FrameRect(hdc, &rect, NtGdiGetStockObject(BLACK_BRUSH));
+    NtGdiSelectPen(hdc, NtGdiGetStockObject(DC_PEN));
+    IntSetDCPenColor(hdc, IntGetSysColor(COLOR_WINDOWFRAME));
+    GreMoveTo(hdc, rect.left, (rect.top + rect.bottom) / 2, NULL);
+    NtGdiLineTo(hdc, rect.right, (rect.top + rect.bottom) / 2);
+#endif
+
+    if (!menuBar)
+    {
+        HBITMAP bm;
+        INT y = rect.top + rect.bottom;
+        RECT rc = rect;
+        BOOL checked = FALSE;
+        UINT check_bitmap_width = UserGetSystemMetrics( SM_CXMENUCHECK );
+        UINT check_bitmap_height = UserGetSystemMetrics( SM_CYMENUCHECK );
+        /* Draw the check mark
+         *
+         * FIXME:
+         * Custom checkmark bitmaps are monochrome but not always 1bpp.
+         */
+        if( !((Menu->fFlags & MNS_STYLE_MASK) & MNS_NOCHECK)) {
+            bm = (lpitem->fState & MF_CHECKED) ? lpitem->hbmpChecked : 
+                lpitem->hbmpUnchecked;
+            if (bm)  /* we have a custom bitmap */
+            {
+                HDC hdcMem = NtGdiCreateCompatibleDC( hdc );
+
+                NtGdiSelectBitmap( hdcMem, bm );
+                NtGdiBitBlt( hdc, rc.left, (y - check_bitmap_height) / 2,
+                        check_bitmap_width, check_bitmap_height,
+                        hdcMem, 0, 0, SRCCOPY, 0,0);
+                IntGdiDeleteDC( hdcMem, FALSE );
+                checked = TRUE;
+            }
+            else if (lpitem->fState & MF_CHECKED) /* standard bitmaps */
+            {
+                RECT r;
+                //HBITMAP bm = CreateBitmap( check_bitmap_width, check_bitmap_height, 1, 1, NULL );
+                //HDC hdcMem = NtGdiCreateCompatibleDC( hdc );
+                //SelectObject( hdcMem, bm );
+                //SetRect( &r, 0, 0, check_bitmap_width, check_bitmap_height);
+                //CopyRect(&r, &rect);
+                r = rect;
+                r.right = r.left + UserGetSystemMetrics(SM_CXMENUCHECK);
+                DrawFrameControl( hdc, &r, DFC_MENU,
+                                 (lpitem->fType & MFT_RADIOCHECK) ?
+                                 DFCS_MENUBULLET : DFCS_MENUCHECK);
+                //NtGdiBitBlt( hdc, rc.left, (y - r.bottom) / 2, r.right, r.bottom, hdcMem, 0, 0, SRCCOPY, 0,0 );
+                //IntGdiDeleteDC( hdcMem, FALSE );
+                //DeleteObject( bm );
+                checked = TRUE;
+            }
+        }
+        if ( lpitem->hbmp )//&& !( checked && (Menu->dwStyle & MNS_CHECKORBMP)))
+        {
+            RECT bmpRect;
+            //CopyRect(&bmpRect, &rect);
+            bmpRect = rect;
+            if (!((Menu->fFlags & MNS_STYLE_MASK) & MNS_CHECKORBMP) && !((Menu->fFlags & MNS_STYLE_MASK) & MNS_NOCHECK))
+                bmpRect.left += check_bitmap_width + 2;
+            if (!(checked && ((Menu->fFlags & MNS_STYLE_MASK) & MNS_CHECKORBMP)))
+            {
+                //POINT origorg;
+                bmpRect.right = bmpRect.left + lpitem->cxBmp;
+                /* some applications make this assumption on the DC's origin */
+                //SetViewportOrgEx( hdc, rect.left, rect.top, &origorg);
+                MENU_DrawBitmapItem(hdc, lpitem, &bmpRect, Menu, WndOwner, odaction, menuBar);
+                //SetViewportOrgEx( hdc, origorg.x, origorg.y, NULL);
+            }
+        }
+        /* Draw the popup-menu arrow */
+        if (lpitem->spSubMenu)
+        {
+           /* RECT rectTemp;
+            CopyRect(&rectTemp, &rect);
+            rectTemp.left = rectTemp.right - UserGetSystemMetrics(SM_CXMENUCHECK);
+            DrawFrameControl(hdc, &rectTemp, DFC_MENU, DFCS_MENUARROW);
+            */
+            draw_popup_arrow( hdc, rect, arrow_bitmap_width, arrow_bitmap_height);
+        }
+        rect.left += 4;
+        if( !((Menu->fFlags & MNS_STYLE_MASK) & MNS_NOCHECK))
+            rect.left += check_bitmap_width;
+        rect.right -= arrow_bitmap_width;//check_bitmap_width;
+    }
+    else if( lpitem->hbmp)
+    { /* Draw the bitmap */
+        //POINT origorg;
+
+        //SetViewportOrgEx( hdc, rect.left, rect.top, &origorg);
+        MENU_DrawBitmapItem(hdc, lpitem, &rect, Menu, WndOwner, odaction, menuBar);
+        //SetViewportOrgEx( hdc, origorg.x, origorg.y, NULL);
+    }
+
+    /* process text if present */
+    if (lpitem->Xlpstr)
+    {
+        int i = 0;
+        HFONT hfontOld = 0;
+
+        UINT uFormat = menuBar ?
+                       DT_CENTER | DT_VCENTER | DT_SINGLELINE :
+                       DT_LEFT | DT_VCENTER | DT_SINGLELINE;
+
+        if (((Menu->fFlags & MNS_STYLE_MASK) & MNS_CHECKORBMP))
+             rect.left += max(0, (int)(Menu->cxTextAlign - UserGetSystemMetrics(SM_CXMENUCHECK)));
+        else
+             rect.left += Menu->cxTextAlign;
+
+        if ( lpitem->fState & MFS_DEFAULT )
+        {
+            hfontOld = NtGdiSelectFont(hdc, ghMenuFontBold);
+        }
+
+        if (menuBar) {
+            if( lpitem->hbmp)
+              rect.left += lpitem->cxBmp;
+            if( !(lpitem->hbmp == HBMMENU_CALLBACK)) 
+              rect.left += MenuCharSize.cx;
+            rect.right -= MenuCharSize.cx;
+            //rect.left += MENU_BAR_ITEMS_SPACE / 2;
+            //rect.right -= MENU_BAR_ITEMS_SPACE / 2;
+        }
+
+        Text = lpitem->Xlpstr;
+        if(Text)
+        {
+            for (i = 0; L'\0' != Text[i]; i++)
+                if (Text[i] == L'\t' || Text[i] == L'\b')
+                    break;
+        }
+
+        if(lpitem->fState & MF_GRAYED)
+        {
+            if (!(lpitem->fState & MF_HILITE) )
+            {
+                ++rect.left; ++rect.top; ++rect.right; ++rect.bottom;
+                IntGdiSetTextColor(hdc, RGB(0xff, 0xff, 0xff));
+                DrawTextW( hdc, Text, i, &rect, uFormat );
+                --rect.left; --rect.top; --rect.right; --rect.bottom;
+	        }
+            IntGdiSetTextColor(hdc, RGB(0x80, 0x80, 0x80));
+        }
+        DrawTextW( hdc, Text, i, &rect, uFormat);
+
+        /* paint the shortcut text */
+        if (!menuBar && L'\0' != Text[i])  /* There's a tab or flush-right char */
+        {
+            if (L'\t' == Text[i])
+            {
+                rect.left = lpitem->dxTab;
+                uFormat = DT_LEFT | DT_VCENTER | DT_SINGLELINE;
+            }
+            else
+            {
+                rect.right = lpitem->dxTab;
+                uFormat = DT_RIGHT | DT_VCENTER | DT_SINGLELINE;
+            }
+
+            if (lpitem->fState & MF_GRAYED)
+            {
+                if (!(lpitem->fState & MF_HILITE) )
+                {
+                    ++rect.left; ++rect.top; ++rect.right; ++rect.bottom;
+                    IntGdiSetTextColor(hdc, RGB(0xff, 0xff, 0xff));
+                    DrawTextW( hdc, Text + i + 1, -1, &rect, uFormat);
+                    --rect.left; --rect.top; --rect.right; --rect.bottom;
+                }
+                IntGdiSetTextColor(hdc, RGB(0x80, 0x80, 0x80));
+            }
+            DrawTextW( hdc, Text + i + 1, -1, &rect, uFormat );
+        }
+
+        if (hfontOld)
+          NtGdiSelectFont (hdc, hfontOld);
+    }
+}
+
+/***********************************************************************
+ *           MenuDrawPopupMenu
+ *
+ * Paint a popup menu.
+ */
+static void FASTCALL MENU_DrawPopupMenu(PWND wnd, HDC hdc, PMENU menu )
+{
+    HBRUSH hPrevBrush = 0, brush = IntGetSysColorBrush(COLOR_MENU);
+    RECT rect;
+
+    TRACE("wnd=%p dc=%p menu=%p\n", wnd, hdc, menu);
+
+    IntGetClientRect( wnd, &rect );
+
+    if (menu && menu->hbrBack) brush = menu->hbrBack;
+    if((hPrevBrush = NtGdiSelectBrush( hdc, brush ))
+        && (NtGdiSelectFont( hdc, ghMenuFont)))
+    {
+        HPEN hPrevPen;
+
+        NtGdiRectangle( hdc, rect.left, rect.top, rect.right, rect.bottom );
+
+        hPrevPen = NtGdiSelectPen( hdc, NtGdiGetStockObject( NULL_PEN ) );
+        if ( hPrevPen )
+        {
+            BOOL flat_menu = FALSE;
+
+            UserSystemParametersInfo (SPI_GETFLATMENU, 0, &flat_menu, 0);
+            if (flat_menu)
+               FrameRect(hdc, &rect, IntGetSysColorBrush(COLOR_BTNSHADOW));
+            else
+               DrawEdge (hdc, &rect, EDGE_RAISED, BF_RECT);
+
+            //TRACE("hmenu %p Style %08x\n", hmenu, menu->dwStyle);
+            /* draw menu items */
+            if (menu && menu->cItems)
+            {
+                ITEM *item;
+                UINT u;
+
+                item = menu->rgItems;
+                for (u = menu->cItems; u > 0; u--, item++)
+                {
+                    MENU_DrawMenuItem(wnd, menu, menu->spwndNotify, hdc, item,
+                                         menu->cyMenu, FALSE, ODA_DRAWENTIRE);
+                }
+                /* draw scroll arrows */
+                if (menu->dwArrowsOn)
+                {
+                   MENU_DrawScrollArrows(menu, hdc);
+                }
+
+            }
+         } else
+         {
+             NtGdiSelectBrush( hdc, hPrevBrush );
+         }
+    }
+}
+
+/**********************************************************************
+ *         MENU_IsMenuActive
+ */
+PWND MENU_IsMenuActive(VOID)
+{
+   PTHREADINFO pti = PsGetCurrentThreadWin32Thread();
+   if (pti->pMenuState->pGlobalPopupMenu)
+   {
+      return IntGetMSWND(pti->pMenuState);
+   }
+   return NULL; // top_popup
+}
+
+/**********************************************************************
+ *         MENU_EndMenu
+ *
+ * Calls EndMenu() if the hwnd parameter belongs to the menu owner
+ *
+ * Does the (menu stuff) of the default window handling of WM_CANCELMODE
+ */
+void MENU_EndMenu( PWND pwnd )
+{
+    PPOPUPMENU top_popup_menu;
+    PMENUSTATE pms = pwnd->head.pti->pMenuState;
+    
+    top_popup_menu = pms->pGlobalPopupMenu;
+    if (top_popup_menu)
+    {
+    }
+/*
+    MENU *menu;
+    menu = top_popup_hmenu ? MENU_GetMenu( top_popup_hmenu ) : NULL;
+    if (menu && ( hwnd == menu->hWnd ||  hwnd == (menu->spwndNotify ? menu->spwndNotify->head.h : NULL)) )
+       EndMenu();
+*/
+}
+
+DWORD WINAPI
+IntDrawMenuBarTemp(PWND pWnd, HDC hDC, LPRECT Rect, PMENU pMenu, HFONT Font)
+{
+  UINT i;
+  HFONT FontOld = NULL;
+  BOOL flat_menu = FALSE;
+
+  UserSystemParametersInfo(SPI_GETFLATMENU, 0, &flat_menu, 0);
+
+  if (!pMenu)
+  {
+      pMenu = UserGetMenuObject(UlongToHandle(pWnd->IDMenu));
+  }
+
+  if (!Font)
+  {
+      Font = ghMenuFont;
+  }
+
+  if (Rect == NULL || !pMenu)
+  {
+      return UserGetSystemMetrics(SM_CYMENU);
+  }
+
+  TRACE("(%x, %x, %p, %x, %x)\n", pWnd, hDC, Rect, pMenu, Font);
+
+  FontOld = NtGdiSelectFont(hDC, Font);
+
+  if (pMenu->cyMenu == 0)
+  {
+      MENU_MenuBarCalcSize(hDC, Rect, pMenu, pWnd);
+  }
+
+  Rect->bottom = Rect->top + pMenu->cyMenu;
+
+  FillRect(hDC, Rect, IntGetSysColorBrush(flat_menu ? COLOR_MENUBAR : COLOR_MENU));
+
+  NtGdiSelectPen(hDC, NtGdiGetStockObject(DC_PEN));
+  IntSetDCPenColor(hDC, IntGetSysColor(COLOR_3DFACE));
+  GreMoveTo(hDC, Rect->left, Rect->bottom - 1, NULL);
+  NtGdiLineTo(hDC, Rect->right, Rect->bottom - 1);
+
+  if (pMenu->cItems == 0)
+  {
+      NtGdiSelectFont(hDC, FontOld);
+      return UserGetSystemMetrics(SM_CYMENU);
+  }
+
+  for (i = 0; i < pMenu->cItems; i++)
+  {
+      MENU_DrawMenuItem(pWnd, pMenu, pWnd, hDC, &pMenu->rgItems[i], pMenu->cyMenu, TRUE, ODA_DRAWENTIRE);
+  }
+
+  NtGdiSelectFont(hDC, FontOld);
+
+  return pMenu->cyMenu;
+}
+
+
+UINT MENU_DrawMenuBar( HDC hDC, LPRECT lprect, PWND pWnd, BOOL suppress_draw )
+{
+    HFONT hfontOld = 0;
+    PMENU lppop = UserGetMenuObject(UlongToHandle(pWnd->IDMenu));
+
+    if (lppop == NULL || lprect == NULL)
+    {
+        return UserGetSystemMetrics(SM_CYMENU);
+    }
+
+    if (suppress_draw)
+    {
+       hfontOld = NtGdiSelectFont(hDC, ghMenuFont);
+
+       MENU_MenuBarCalcSize(hDC, lprect, lppop, pWnd);
+
+       lprect->bottom = lprect->top + lppop->cyMenu;
+
+       if (hfontOld) NtGdiSelectFont( hDC, hfontOld);
+       return lppop->cyMenu;
+    }   
+    else
+    {
+       return IntDrawMenuBarTemp(pWnd, hDC, lprect, lppop, NULL);
+    }
+}
+
+/***********************************************************************
+ *           MENU_InitPopup
+ *   
+ * Popup menu initialization before WM_ENTERMENULOOP.
+ */
+static BOOL MENU_InitPopup( PWND pWndOwner, PMENU menu, UINT flags )
+{
+    PWND pWndCreated;
+    PPOPUPMENU pPopupMenu;
+    CREATESTRUCTW Cs;
+    LARGE_STRING WindowName;
+    UNICODE_STRING ClassName;
+    PCLS pcls;
+    DWORD ex_style = WS_EX_TOOLWINDOW;
+
+    TRACE("owner=%p hmenu=%p\n", pWndOwner, menu);
+
+    menu->spwndNotify = pWndOwner;
+
+    if (flags & TPM_LAYOUTRTL || pWndOwner->ExStyle & WS_EX_LAYOUTRTL)
+       ex_style = WS_EX_LAYOUTRTL;
+
+    ClassName.Buffer = WC_MENU;
+    ClassName.Length = 0;
+    pcls = IntGetAndReferenceClass(&ClassName, 0, TRUE);
+    if (pcls == NULL)
+    {
+       ASSERT(FALSE);
+       return FALSE;
+    }
+
+    RtlZeroMemory(&WindowName, sizeof(WindowName));
+    RtlZeroMemory(&Cs, sizeof(Cs));
+    Cs.style = WS_POPUP;
+    Cs.dwExStyle = ex_style;
+    Cs.hInstance = hModClient; // hModuleWin; // Server side winproc!
+    Cs.lpszName = (LPCWSTR) &WindowName;
+    Cs.lpszClass = (LPCWSTR) &ClassName;
+    Cs.lpCreateParams = UserHMGetHandle(menu);
+
+    /* NOTE: In Windows, top menu popup is not owned. */
+    pWndCreated = IntCreateWindow(&Cs, &WindowName, pcls, pWndOwner, NULL, NULL, pWndOwner->head.rpdesk);
+
+    if( !pWndCreated ) return FALSE;
+
+    //
+    //  Setup pop up menu structure.
+    //
+    menu->hWnd = UserHMGetHandle(pWndCreated);
+
+    pPopupMenu = ((PMENUWND)pWndCreated)->ppopupmenu;
+    pPopupMenu->spwndActivePopup = pWndCreated; // top_popup = MenuInfo.Wnd or menu->hWnd
+    pPopupMenu->spwndNotify = pWndOwner;        // Same as MenuInfo.spwndNotify(which could be wrong) or menu->hwndOwner
+    pPopupMenu->spmenu = menu;                  // top_popup_hmenu = hMenu
+
+    pPopupMenu->fIsTrackPopup = !!(flags & TPM_POPUPMENU);  // if TRUE, spwndPopupMenu should be set?
+    pPopupMenu->fIsSysMenu    = !!(flags & TPM_SYSTEM_MENU);
+    pPopupMenu->fNoNotify     = !!(flags & TPM_NONOTIFY);
+    pPopupMenu->fRightButton  = !!(flags & TPM_RIGHTBUTTON);
+    pPopupMenu->fSynchronous  = !!(flags & TPM_RETURNCMD);
+
+    if (pPopupMenu->fRightButton)
+       pPopupMenu->fFirstClick = !!(UserGetKeyState(VK_RBUTTON) & 0x8000);
+    else
+       pPopupMenu->fFirstClick = !!(UserGetKeyState(VK_LBUTTON) & 0x8000);
+
+    if (gpsi->aiSysMet[SM_MENUDROPALIGNMENT] ||
+        menu->fFlags & MNF_RTOL)
+    {
+       pPopupMenu->fDroppedLeft = TRUE;
+    }
+
+    return TRUE;
+}
+
+/***********************************************************************
+ *           MenuShowPopup
+ *
+ * Display a popup menu.
+ */
+static BOOL FASTCALL MENU_ShowPopup(PWND pwndOwner, PMENU menu, UINT id, UINT flags,
+                              INT x, INT y, INT xanchor, INT yanchor )
+{
+    UINT width, height;
+    POINT pt;
+    PMONITOR monitor;
+    PWND pWnd;
+
+    TRACE("owner=%p menu=%p id=0x%04x x=0x%04x y=0x%04x xa=0x%04x ya=0x%04x\n",
+          pwndOwner, menu, id, x, y, xanchor, yanchor);
+
+    if (menu->iItem != NO_SELECTED_ITEM)
+    {
+        menu->rgItems[menu->iItem].fState &= ~(MF_HILITE|MF_MOUSESELECT);
+        menu->iItem = NO_SELECTED_ITEM;
+    }
+
+    menu->dwArrowsOn = 0;
+    MENU_PopupMenuCalcSize(menu, pwndOwner);
+
+    /* adjust popup menu pos so that it fits within the desktop */
+
+    width = menu->cxMenu + UserGetSystemMetrics(SM_CXBORDER);
+    height = menu->cyMenu + UserGetSystemMetrics(SM_CYBORDER);
+
+    /* FIXME: should use item rect */
+    pt.x = x;
+    pt.y = y;
+    monitor = UserMonitorFromPoint( pt, MONITOR_DEFAULTTONEAREST );
+
+    if (flags & TPM_LAYOUTRTL) 
+        flags ^= TPM_RIGHTALIGN;
+
+    if( flags & TPM_RIGHTALIGN ) x -= width;
+    if( flags & TPM_CENTERALIGN ) x -= width / 2;
+
+    if( flags & TPM_BOTTOMALIGN ) y -= height;
+    if( flags & TPM_VCENTERALIGN ) y -= height / 2;
+
+    if( x + width > monitor->rcMonitor.right)
+    {
+        if( xanchor && x >= width - xanchor )
+            x -= width - xanchor;
+
+        if( x + width > monitor->rcMonitor.right)
+            x = monitor->rcMonitor.right - width;
+    }
+    if( x < monitor->rcMonitor.left ) x = monitor->rcMonitor.left;
+
+    if( y + height > monitor->rcMonitor.bottom)
+    {
+        if( yanchor && y >= height + yanchor )
+            y -= height + yanchor;
+
+        if( y + height > monitor->rcMonitor.bottom)
+            y = monitor->rcMonitor.bottom - height;
+    }
+    if( y < monitor->rcMonitor.top ) y = monitor->rcMonitor.top;
+
+    pWnd = ValidateHwndNoErr( menu->hWnd );
+/*
+    if (!top_popup) {
+        top_popup = menu->hWnd;
+        top_popup_hmenu = hmenu;
+    }
+ */
+    /* Display the window */
+
+    co_WinPosSetWindowPos( pWnd, HWND_TOPMOST, x, y, width, height, SWP_SHOWWINDOW | SWP_NOACTIVATE);
+
+    co_IntUpdateWindows(pWnd, RDW_ALLCHILDREN, FALSE);
+
+    IntNotifyWinEvent(EVENT_SYSTEM_MENUPOPUPSTART, pWnd, OBJID_CLIENT, CHILDID_SELF, 0);
+
+    return TRUE;
+}
+
+/***********************************************************************
+ *           MENU_EnsureMenuItemVisible
+ */
+void
+MENU_EnsureMenuItemVisible(PMENU lppop, UINT wIndex, HDC hdc)
+{
+    if (lppop->dwArrowsOn)
+    {
+        ITEM *item = &lppop->rgItems[wIndex];
+        UINT nMaxHeight = MENU_GetMaxPopupHeight(lppop);
+        UINT nOldPos = lppop->iTop;
+        RECT rc;
+        UINT arrow_bitmap_height;
+        PWND pWnd = ValidateHwndNoErr(lppop->hWnd);
+
+        IntGetClientRect(pWnd, &rc);
+
+        arrow_bitmap_height = gpsi->oembmi[OBI_DNARROW].cy;
+
+        rc.top += arrow_bitmap_height;
+        rc.bottom -= arrow_bitmap_height + MENU_BOTTOM_MARGIN;
+
+        nMaxHeight -= UserGetSystemMetrics(SM_CYBORDER) + 2 * arrow_bitmap_height;
+        if (item->cyItem > lppop->iTop + nMaxHeight)
+        {
+            lppop->iTop = item->cyItem - nMaxHeight;
+            IntScrollWindow(pWnd, 0, nOldPos - lppop->iTop, &rc, &rc);
+            MENU_DrawScrollArrows(lppop, hdc);
+            //ERR("Scroll Down iTop %d iMaxTop %d nMaxHeight %d\n",lppop->iTop,lppop->iMaxTop,nMaxHeight);
+        }
+        else if (item->yItem - MENU_TOP_MARGIN < lppop->iTop)
+        {
+            lppop->iTop = item->yItem - MENU_TOP_MARGIN;
+            IntScrollWindow(pWnd, 0, nOldPos - lppop->iTop, &rc, &rc);
+            MENU_DrawScrollArrows(lppop, hdc);
+            //ERR("Scroll Up   iTop %d iMaxTop %d nMaxHeight %d\n",lppop->iTop,lppop->iMaxTop,nMaxHeight);
+        }
+    }
+}
+
+/***********************************************************************
+ *           MenuSelectItem
+ */
+static
+void FASTCALL MENU_SelectItem(PWND pwndOwner, PMENU menu, UINT wIndex,
+                                    BOOL sendMenuSelect, PMENU topmenu)
+{
+    HDC hdc;
+    PWND pWnd = ValidateHwndNoErr(menu->hWnd);
+
+    TRACE("owner=%p menu=%p index=0x%04x select=0x%04x\n", pwndOwner, menu, wIndex, sendMenuSelect);
+
+    if (!menu || !menu->cItems || !pWnd) return;
+    if (menu->iItem == wIndex) return;
+
+    if (menu->fFlags & MNF_POPUP)
+       hdc = UserGetDCEx(pWnd, 0, DCX_USESTYLE);
+    else
+       hdc = UserGetDCEx(pWnd, 0, DCX_CACHE | DCX_WINDOW);
+   /*
+    if (!top_popup) { 
+        top_popup = lppop->hWnd; pPopupMenu->spwndActivePopup or
+                                 pPopupMenu->fIsTrackPopup set pPopupMenu->spwndPopupMenu;
+        top_popup_hmenu = hmenu; pPopupMenu->spmenu
+    }
+    */
+    NtGdiSelectFont( hdc, ghMenuFont );
+
+     /* Clear previous highlighted item */
+    if (menu->iItem != NO_SELECTED_ITEM)
+    {
+        menu->rgItems[menu->iItem].fState &= ~(MF_HILITE|MF_MOUSESELECT);
+        MENU_DrawMenuItem(pWnd, menu, pwndOwner, hdc, &menu->rgItems[menu->iItem],
+                       menu->cyMenu, !(menu->fFlags & MNF_POPUP),
+                       ODA_SELECT);
+    }
+
+    /* Highlight new item (if any) */
+    menu->iItem = wIndex;
+    if (menu->iItem != NO_SELECTED_ITEM)
+    {
+        if (!(menu->rgItems[wIndex].fType & MF_SEPARATOR))
+        {
+             menu->rgItems[wIndex].fState |= MF_HILITE;
+             MENU_EnsureMenuItemVisible(menu, wIndex, hdc);
+             MENU_DrawMenuItem(pWnd, menu, pwndOwner, hdc,
+                               &menu->rgItems[wIndex], menu->cyMenu, !(menu->fFlags & MNF_POPUP), ODA_SELECT);
+        }
+        if (sendMenuSelect)
+        {
+           ITEM *ip = &menu->rgItems[menu->iItem];
+           WPARAM wParam = MAKEWPARAM( ip->spSubMenu ? wIndex : ip->wID, 
+                                       ip->fType | ip->fState |
+                                      (ip->spSubMenu ? MF_POPUP : 0) |
+                                      (menu->fFlags & MNF_SYSMENU ? MF_SYSMENU : 0 ) );
+
+           co_IntSendMessage(UserHMGetHandle(pwndOwner), WM_MENUSELECT, wParam, (LPARAM) UserHMGetHandle(menu));
+        }
+    }
+    else if (sendMenuSelect) 
+    {
+        if (topmenu) 
+        {
+            int pos;
+            pos = MENU_FindSubMenu(&topmenu, menu);
+            if (pos != NO_SELECTED_ITEM)
+            {
+               ITEM *ip = &topmenu->rgItems[pos];
+               WPARAM wParam = MAKEWPARAM( Pos, ip->fType | ip->fState |
+                                           (ip->spSubMenu ? MF_POPUP : 0) |
+                                           (topmenu->fFlags & MNF_SYSMENU ? MF_SYSMENU : 0 ) );
+
+               co_IntSendMessage(UserHMGetHandle(pwndOwner), WM_MENUSELECT, wParam, (LPARAM) UserHMGetHandle(topmenu));
+            }
+        }
+    }
+    UserReleaseDC(pWnd, hdc, FALSE);
+}
+
+/***********************************************************************
+ *           MenuMoveSelection
+ *
+ * Moves currently selected item according to the Offset parameter.
+ * If there is no selection then it should select the last item if
+ * Offset is ITEM_PREV or the first item if Offset is ITEM_NEXT.
+ */
+static void FASTCALL
+MENU_MoveSelection(PWND WndOwner, PMENU Menu, INT Offset)
+{
+  INT i;
+  INT OrigPos;
+
+  TRACE("hwnd=%x menu=%x off=0x%04x\n", WndOwner, Menu, Offset);
+
+  /* Prevent looping */
+  if (0 == Menu->cItems || 0 == Offset)
+    return;
+  else if (Offset < -1)
+    Offset = -1;
+  else if (Offset > 1)
+    Offset = 1;
+
+  OrigPos = Menu->iItem;
+  if (OrigPos == NO_SELECTED_ITEM) /* NO_SELECTED_ITEM is not -1 ! */
+  {
+       OrigPos = 0;
+       i = -1;
+  }
+  else
+  {
+      i = Menu->iItem;
+  }
+
+  do
+  {   /* Step */
+      i += Offset;
+      /* Clip and wrap around */
+      if (i < 0)
+      {
+          i = Menu->cItems - 1;
+      }
+      else if (i >= Menu->cItems)
+      {
+          i = 0;
+      }
+      /* If this is a good candidate; */
+      if (!(Menu->rgItems[i].fType & MF_SEPARATOR))
+      {
+          MENU_SelectItem(WndOwner, Menu, i, TRUE, NULL);
+          return;
+      }
+  } while (i != OrigPos);
+
+  /* Not found */
+}
+
+/***********************************************************************
+ *           MenuHideSubPopups
+ *
+ * Hide the sub-popup menus of this menu.
+ */
+static void FASTCALL
+MENU_HideSubPopups(PWND pWndOwner, PMENU Menu,
+                               BOOL SendMenuSelect, UINT wFlags)
+{
+  HWND top_popup = Menu->hWnd; // HAX for now just to get hilite to work.
+
+  TRACE("owner=%x menu=%x 0x%04x\n", pWndOwner, Menu, SendMenuSelect);
+
+  if (Menu && top_popup)
+  {
+      PITEM Item;
+
+      if (Menu->iItem != NO_SELECTED_ITEM)
+      {
+         Item = &Menu->rgItems[Menu->iItem];
+         if (!(Item->spSubMenu) ||
+             !(Item->fState & MF_MOUSESELECT)) return;
+         Item->fState &= ~MF_MOUSESELECT;
+      }
+      else
+         return;
+
+      if (Item->spSubMenu)
+      {
+          PWND pWnd = ValidateHwndNoErr(Item->spSubMenu->hWnd);
+          MENU_HideSubPopups(pWndOwner, Item->spSubMenu, FALSE, wFlags);
+          MENU_SelectItem(pWndOwner, Item->spSubMenu, NO_SELECTED_ITEM, SendMenuSelect, NULL);
+
+          co_UserDestroyWindow(pWnd);
+
+          /* Native returns handle to destroyed window */
+          if (!(wFlags & TPM_NONOTIFY))
+             co_IntSendMessage( UserHMGetHandle(pWndOwner), WM_UNINITMENUPOPUP, (WPARAM)UserHMGetHandle(Item->spSubMenu),
+                                 MAKELPARAM(0, IS_SYSTEM_MENU(Item->spSubMenu)) );
+          ////
+          // Call WM_UNINITMENUPOPUP FIRST before destroy!!
+          // Fixes todo_wine User32 test menu.c line 2233 GetMenuBarInfo callback....
+          //
+          Item->spSubMenu->hWnd = NULL;
+          ////
+      }
+  }
+}
+
+/***********************************************************************
+ *           MenuShowSubPopup
+ *
+ * Display the sub-menu of the selected item of this menu.
+ * Return the handle of the submenu, or menu if no submenu to display.
+ */
+//static
+PMENU FASTCALL
+MENU_ShowSubPopup(PWND WndOwner, PMENU Menu, BOOL SelectFirst, UINT Flags)
+{
+  RECT Rect;
+  ITEM *Item;
+  HDC Dc;
+  PWND pWnd;
+
+  TRACE("owner=%x menu=%p 0x%04x\n", WndOwner, Menu, SelectFirst);
+
+  if (Menu->iItem == NO_SELECTED_ITEM) return Menu;
+  
+  Item = &Menu->rgItems[Menu->iItem];
+  if (!(Item->spSubMenu) || (Item->fState & (MF_GRAYED | MF_DISABLED)))
+      return Menu;
+
+  /* message must be sent before using item,
+     because nearly everything may be changed by the application ! */
+
+  /* Send WM_INITMENUPOPUP message only if TPM_NONOTIFY flag is not specified */
+  if (!(Flags & TPM_NONOTIFY))
+  {
+      co_IntSendMessage(UserHMGetHandle(WndOwner), WM_INITMENUPOPUP,
+                        (WPARAM) UserHMGetHandle(Item->spSubMenu),
+                         MAKELPARAM(Menu->iItem, IS_SYSTEM_MENU(Menu)));
+  }
+
+  Item = &Menu->rgItems[Menu->iItem];
+  //Rect = ItemInfo.Rect;
+  Rect.left   = Item->xItem;
+  Rect.top    = Item->yItem;
+  Rect.right  = Item->cxItem; // Do this for now......
+  Rect.bottom = Item->cyItem;
+
+  pWnd = ValidateHwndNoErr(Menu->hWnd);
+
+  /* correct item if modified as a reaction to WM_INITMENUPOPUP message */
+  if (!(Item->fState & MF_HILITE))
+  {
+      if (Menu->fFlags & MNF_POPUP) Dc = UserGetDCEx(pWnd, NULL, DCX_USESTYLE);
+      else Dc = UserGetDCEx(pWnd, 0, DCX_CACHE | DCX_WINDOW);
+
+      NtGdiSelectFont(Dc, ghMenuFont);
+
+      Item->fState |= MF_HILITE;
+      MENU_DrawMenuItem(pWnd, Menu, WndOwner, Dc, Item, Menu->cyMenu,
+                       !(Menu->fFlags & MNF_POPUP), ODA_DRAWENTIRE);
+      UserReleaseDC(pWnd, Dc, FALSE);
+  }
+
+  if (!Item->yItem && !Item->xItem && !Item->cyItem && !Item->cxItem)
+  {
+      Item->xItem  = Rect.left; 
+      Item->yItem  = Rect.top;  
+      Item->cxItem = Rect.right; // Do this for now...... 
+      Item->cyItem = Rect.bottom;
+  }
+  Item->fState |= MF_MOUSESELECT;
+
+  if (IS_SYSTEM_MENU(Menu))
+  {
+      MENU_InitSysMenuPopup(Item->spSubMenu, pWnd->style, pWnd->pcls->style, HTSYSMENU);
+
+      NC_GetSysPopupPos(pWnd, &Rect);
+      if (Flags & TPM_LAYOUTRTL) Rect.left = Rect.right;
+      Rect.top = Rect.bottom;
+      Rect.right = UserGetSystemMetrics(SM_CXSIZE);
+      Rect.bottom = UserGetSystemMetrics(SM_CYSIZE);
+  }
+  else
+  {
+      IntGetWindowRect(pWnd, &Rect);
+      if (Menu->fFlags & MNF_POPUP)
+      {
+          RECT rc;
+          rc.left   = Item->xItem;
+          rc.top    = Item->yItem;
+          rc.right  = Item->cxItem; // Do this for now......
+          rc.bottom = Item->cyItem;
+
+          MENU_AdjustMenuItemRect(Menu, &rc);
+
+          /* The first item in the popup menu has to be at the
+             same y position as the focused menu item */
+          if(Flags & TPM_LAYOUTRTL)
+             Rect.left += UserGetSystemMetrics(SM_CXBORDER);
+          else
+             Rect.left += rc.right /*ItemInfo.Rect.right*/ - UserGetSystemMetrics(SM_CXBORDER);
+          Rect.top += rc.top - MENU_TOP_MARGIN;//3;
+          Rect.right = rc.left - rc.right + UserGetSystemMetrics(SM_CXBORDER);
+          Rect.bottom = rc.top - rc.bottom - MENU_TOP_MARGIN - MENU_BOTTOM_MARGIN/*2*/
+                                                     - UserGetSystemMetrics(SM_CYBORDER);
+      }
+      else
+      {
+          if(Flags & TPM_LAYOUTRTL)
+              Rect.left += Rect.right - Item->xItem; //ItemInfo.Rect.left;
+          else
+              Rect.left += Item->xItem; //ItemInfo.Rect.left;
+          Rect.top += Item->cyItem; //ItemInfo.Rect.bottom;
+          Rect.right  = Item->cxItem - Item->xItem; //ItemInfo.Rect.right - ItemInfo.Rect.left;
+          Rect.bottom = Item->cyItem - Item->yItem; //ItemInfo.Rect.bottom - ItemInfo.Rect.top;
+      }
+  }
+
+  /* use default alignment for submenus */
+  Flags &= ~(TPM_CENTERALIGN | TPM_RIGHTALIGN | TPM_VCENTERALIGN | TPM_BOTTOMALIGN);
+
+  MENU_InitPopup( WndOwner, Item->spSubMenu, Flags );
+
+  MENU_ShowPopup( WndOwner, Item->spSubMenu, Menu->iItem, Flags,
+                Rect.left, Rect.top, Rect.right, Rect.bottom );
+  if (SelectFirst)
+  {
+      MENU_MoveSelection(WndOwner, Item->spSubMenu, ITEM_NEXT);
+  }
+  return Item->spSubMenu;
+}
+
+
+VOID FASTCALL
 co_IntInitTracking(PWND Window, PMENU Menu, BOOL Popup,
                    UINT Flags)
 {
